<?PHP
/* $Id: info.php,v 1.4 2002/03/12 16:55:55 bzizou Exp $

Print informations about the SLIS

This script is part of the SLIS Project initiated by the CARMI-Internet
(Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet
(Acadmie de Grenoble - France 38).

This script have been writen by Bruno Bzeznik - copyright (C) 2001
Ce script  t crit par Bruno Bzeznik - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire.
Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License
along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail
to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  <slis@ac-grenoble.fr>
*/

// loading libs and init
require("../inc/html.inc.php");
require("../inc/lib.inc.php");
print startHTML("Df");


// CPUINFO
if ( $action == "cpu" ) {
  exec("/bin/cat /proc/cpuinfo",$res);
  $text = "<B>CPU:</B><P><TT><PRE>\n";
  for ($i=0;$i<count($res);$i++) {
    $text .= $res[$i] ."\n";
  }
  $text .= "</PRE></TT>\n";  
}

// MEMORY
elseif ( $action == "memory" ) {
  exec("free",$res);
  $text = "<B>MEMORY:</B><P><TT><PRE>\n";
  for ($i=0;$i<count($res);$i++) {
    $text .= $res[$i] ."\n";
  }
  $text .= "</PRE></TT>\n";  
}

// CHARGE
elseif ( $action == "charge" ) {
  exec("w -s",$res);
  $text = "<B>CHARGE:</B><P><TT><PRE>\n";
  $text .= $res[0] ."\n";
  $text .= "</PRE></TT>\n";  
}

// FS
elseif ( $action == "disks" ) {
  exec("df",$res);
  $text = "<B>FILE SYSTEMS:</B><P><TT><PRE>\n";
  for ($i=0;$i<count($res);$i++) {
    $text .= $res[$i] ."\n";
  }
  $text .= "</PRE></TT>\n";  
}

// IF
elseif ( $action == "if" ) {
  exec("/sbin/ifconfig -a;echo;/bin/netstat -rn",$res);
  $text = "<B>INTERFACES/ROUTES:</B><P><TT><PRE>\n";
  for ($i=0;$i<count($res);$i++) {
    $text .= $res[$i] ."\n";
  }
  $text .= "</PRE></TT>\n";  
}

// PCI
elseif ( $action == "pci" ) {
  exec("/bin/cat /proc/pci",$res);
  $text = "<B>PCI:</B><P><TT><PRE>\n";
  for ($i=0;$i<count($res);$i++) {
    $text .= $res[$i] ."\n";
  }
  $text .= "</PRE></TT>\n";  
}

// INTERRUPTS and IO
elseif ( $action == "irqio" ) {
  exec("cat /proc/interrupts; echo; cat /proc/ioports",$res);
  $text = "<B>IRQ & IO:</B><P><TT><PRE>\n";
  for ($i=0;$i<count($res);$i++) {
    $text .= $res[$i] ."\n";
  }
  $text .= "</PRE></TT>\n";  
}

// MODULES
elseif ( $action == "modules" ) {
  exec("/sbin/lsmod",$res);
  $text = "<B>MODULES:</B><P><TT><PRE>\n";
  for ($i=0;$i<count($res);$i++) {
    $text .= $res[$i] ."\n";
  }
  $text .= "</PRE></TT>\n";  
}

// UNAME
elseif ( $action == "uname" ) {
  exec("uname -a",$res);
  $text = "<B>uname -a:</B><P><TT><PRE>\n";
  for ($i=0;$i<count($res);$i++) {
    $text .= $res[$i] ."\n";
  }
  $text .= "</PRE></TT>\n";  
}

// DMESG
elseif ( $action == "dmesg" ) {
  exec("dmesg",$res);
  $text = "<B>dmesg:</B><P><TT><PRE>\n";
  for ($i=0;$i<count($res);$i++) {
    $text .= $res[$i] ."\n";
  }
  $text .= "</PRE></TT>\n";  
}

// LAST LOGS
elseif ( $action == "lastlogs" ) {
  exec("tail -200 /var/log/messages",$res);
  $text = "<B>LAST 200 SYSTEM LOG LINES:</B><P><TT><PRE>\n";
  for ($i=0;$i<count($res);$i++) {
    $text .= $res[$i] ."\n";
  }
  $text .= "</PRE></TT>\n";  
}

// INDEX
else {
  // Search for the variable ROUTER_TYPE (compatibility with older versions)
  if ($ROUTER_TYPE == "") {
    $setup_file="";
    $ROUTEUR="0";
    if (file_exists("/home/hadmin/setup.data")) {
      $setup_file="/home/hadmin/setup.data";
    }
    elseif (file_exists("/root/slis/setup.data")) {
      $setup_file="/root/slis/setup.data";
    }
    else {
      print "<B>FILE setup.data not found!</B><P>";
    }
    if ($setup_file != "") {
      $data=file("$setup_file");
      $grep=array_values(preg_grep("/^\s*ROUTEUR.*=/",$data));
      $eval="$". $grep[0] .";";
      eval ($eval);
    }
    $ROUTER_TYPE=$ROUTEUR;  
  }

  // Version
  $version=file("/etc/version_slis");

  $text ="<BR>\n";
  $text .= "<UL><LI><B>SLIS</B>:<BR>\n";
  $text .= "Version: ". $version[0] ."<BR>\n";
  $text .= "CyberSchool: $CYBERECOLE<BR>\n";
  $text .= "Router type: $ROUTER_TYPE<BR>\n";
  $text .= "ISDN: $ISDN<BR>\n";
  $text .= "VTUN: $VTUN<BR>\n";
  $text .= "DOMAIN: $DOMAIN<BR>\n";
  $text .= "SMART HOST: $SMART_HOST<BR>\n";
  $text .= "UPDATE HOST: $RSYNC_HOST<BR>\n";
  $text .= "PARENT PROXY: $PROXY_CACHE<BR>\n";
  $text .= "</LI><BR><LI><B>HOST</B>:<BR>\n";
  $text .= "<A HREF=./info.php?action=cpu>CPU<BR>\n";
  $text .= "<A HREF=./info.php?action=memory>MEMORY<BR>\n";
  $text .= "<A HREF=./info.php?action=uname>UNAME<BR>\n";
  $text .= "<A HREF=./info.php?action=charge>CHARGE<BR>\n";
  $text .= "<A HREF=./info.php?action=disks>FILE SYSTEMS<BR>\n";
  $text .= "<A HREF=./info.php?action=if>INTERFACES<BR>\n";
  $text .= "<A HREF=./info.php?action=pci>PCI<BR>\n";
  $text .= "<A HREF=./info.php?action=irqio>IRQ and IO<BR>\n";
  $text .= "<A HREF=./info.php?action=modules>MODULES<BR>\n";
  $text .= "<A HREF=./info.php?action=dmesg>DMESG<BR>\n";
  $text .= "<A HREF=./info.php?action=lastlogs>LAST LOGS<BR>\n";
  $text .= "</UL>\n";

  $text .= "<BR>\n";
}

$val =
newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,$lang_adv_Infos,$titre_color); 
$val = center($val);
$val = saut(2)."$val";
print "$val\n";        


// The end
print endHTML();

?>
