<?PHP
/* $Id: stats.php,v 1.12 2002/03/12 16:55:55 bzizou Exp $

Connection stats

This script is part of the SLIS Project initiated by the CARMI-Internet
(Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet
(Acadmie de Grenoble - France 38).

This script have been writen by Bruno Bzeznik - copyright (C) 2001
Ce script  t crit par Bruno Bzeznik - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire.
Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License
along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail
to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  <slis@ac-grenoble.fr>
*/

// loading libs and init
require("../inc/html.inc.php");
require("../inc/lib.inc.php");
require("../inc/pgsql.inc.php");
print startHTML("Conns stats");




// INDEX PAGE
if ($action=="index") {

  // Search for the type of connection (type of router)
  $setup_file="";
  $ROUTEUR="0";
  if (file_exists("/home/hadmin/setup.data")) {
    $setup_file="/home/hadmin/setup.data";
  }
  elseif (file_exists("/root/slis/setup.data")) {
    $setup_file="/root/slis/setup.data";
  }
  else {
    print "<B>FILE setup.data not found!</B><P>";
  }
  if ($setup_file != "") {
    $data=file("$setup_file");
    $grep=array_values(preg_grep("/^\s*ROUTEUR.*=/",$data));
    $eval="$". $grep[0] .";";
    eval ($eval);
  }

  // Prepare the message
  $text = "<BR><FONT FACE=Helvetica,Arial>\n";
  $text .= "<UL><B>\n";
  if ($ROUTEUR != "0") {
    $text .="<LI>$lang_stats_Conns :\n<UL>\n";
    $text .= menu_item("stats.php?action=report_index",$lang_stats_Report,0,0,0);
    $text .= menu_item("stats.php?action=month",$lang_stats_Monthes,0,0,0);
    $text .= "</UL><P>\n";
  }
  $text .="<LI>$lang_stats_Proxy :\n";
  $text .= "<UL>\n";
  $text .= menu_item("http-logs.php?action=index_squid",$lang_stats_Proxy_logs,0,0,0);
  $text .= menu_item("../prostat",$lang_stats_Proxy_stats,0,0,0);
  $text .= "</UL><P>\n";
  $text .="<LI>$lang_stats_Web :\n";
  $text .= "<UL>\n";
  $text .= menu_item("http-logs.php?action=index_apache",$lang_stats_Web_logs,0,0,0);
  $text .= "</UL></B></UL><BR><P>";

  // print the message
  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,$lang_adv_Statsconn,$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";        
}




// LOG REPORT FORM PAGE
if ($action=="report_index") {

  $text=start_stop_form("stats.php","report");
  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,$lang_stats_Report,$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print "$val\n";        
}




// LOG REPORT PAGE
if ($action=="report") {

  // make the time variables
  if ($begin_m<1 || $begin_m>12) { 
    $begin=date("M-d-Y",time()-2592000); 
    $eu_begin=date("d/m/Y",time()-2592000); 
  }
  else { 
     if ($begin_d<1 || $begin_d>31) { $begin_d=1; }
     if ($begin_y<1) { $begin_y=1; }
     $begin=date("M-d-Y",mktime(0,0,0,$begin_m,$begin_d,$begin_y)); 
     $eu_begin=date("d/m/Y",mktime(0,0,0,$begin_m,$begin_d,$begin_y)); 
  }
  if ($end_m<1 || $end_m>12) { 
    $end=date("M-d-Y",time()); 
    $eu_end=date("d/m/Y",time()); 
  }
  else { 
     if ($end_d<1 || $end_d>31) { $end_d=0; $end_m++; }
          if ($end_y<1) { $end_y=1; }
     $end=date("M-d-Y",mktime(0,0,0,$end_m,$end_d,$end_y)); 
     $eu_end=date("d/m/Y",mktime(0,0,0,$end_m,$end_d,$end_y)); 
  }

  // SQL query
  $db = dbconnect();
  $query="select to_char(start,'DD/MM/YYYY HH24:MI:SS') as strt,to_char(stop,'DD/MM/YYYY HH24:MI:SS') as stp,time 
          from conns
          where start>='$begin 00:00:00' and start<='$end 23:59:59'
          order by start";
  $result=pg_exec($db,$query);
  
  // Building of the report
  if (pg_numrows($result)<1) { $report = "<CENTER><I><BR>$lang_stats_Report_nodata<BR><BR></I></CENTER>"; }
  else {
    $report = "<TABLE BORDER=0>\n";
    $report .= "<TR><TD ALIGN=CENTER><FONT FACE=HELVETICA,ARIAL SIZE=-1><B>Start</FONT></B></TD>\n";
    $report .= "<TD ALIGN=CENTER><B><FONT FACE=HELVETICA,ARIAL SIZE=-1>Stop</FONT></B></TD>\n";
    $report .= "<TD ALIGN=CENTER><B><FONT FACE=HELVETICA,ARIAL SIZE=-1>On time&nbsp;&nbsp;</FONT></B></TD></TR>\n";
    $ontime = 0;
    for ($i=0;$i<pg_numrows($result);$i++) {
      $report .= "<TR>\n";
      $report .= "<TD><FONT FACE=HELVETICA,ARIAL SIZE=-1>&nbsp;&nbsp;&nbsp;". pg_result($result,$i,"strt");
      $report .= "&nbsp;&nbsp;&nbsp;</FONT></TD><TD><FONT FACE=HELVETICA,ARIAL SIZE=-1>&nbsp;". pg_result($result,$i,"stp");
      $report .= "&nbsp;&nbsp;&nbsp;</FONT></TD><TD><FONT FACE=HELVETICA,ARIAL SIZE=-1>&nbsp;". sec_to_time(pg_result($result,$i,"time"));
      $report .= "&nbsp;&nbsp;&nbsp;</FONT></TD></TR>\n";
      $ontime += pg_result($result,$i,"time");
    }
    $average=round($ontime/$i);
    $color="#000000";
    if ($average < 60) { $color="#FF0000"; }
    $report .= "<TR><TD><FONT SIZE=-1></FONT></TD><TD ALIGN=RIGHT><FONT FACE=HELVETICA,ARIAL SIZE=-1><B>TOTAL: &nbsp;</B></FONT></TD><TD ALIGN=CENTER><B><FONT FACE=HELVETICA,ARIAL SIZE=-1>". sec_to_time($ontime) ."</FONT></B>&nbsp;</TD></TR>\n";
    $report .= "<TR><TD><FONT SIZE=-1></FONT></TD><TD ALIGN=RIGHT><FONT FACE=HELVETICA,ARIAL SIZE=-1><B>$lang_stats_Report_average: &nbsp;</B></FONT></TD><TD ALIGN=CENTER><B><FONT FACE=HELVETICA,ARIAL SIZE=-1 COLOR=$color>". sec_to_time($average) ."</FONT></B>&nbsp;</TD></TR>\n";
    $report .= "</TABLE>";
  }  
  
  if ($LANGUAGE == "french") { $title = "$eu_begin &nbsp; -> &nbsp; $eu_end"; }
  else { $title = "$begin &nbsp; -> &nbsp; $end"; }

  // Printing of the report
  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$report,$border,$title,$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print $val;
}


// MONTHLY REPORT
if ($action=="month") {

  $m_now=date("m",time());
  $y_now=date("Y",time());
  $end=date("M-d-Y",time()); 

  $text = "<TABLE BORDER=0 COLSPAN=0 CELLPADDING=0>\n";  

  for ($i=12;$i>=0;$i--) {
    $begin=date("M-d-Y",mktime(0,0,0,$m_now-$i,1,$y_now)); 
    $end=date("M-d-Y",mktime(0,0,0,$m_now-$i+1,0,$y_now)); 
    $m=date("m/Y",mktime(0,0,0,$m_now-$i,1,$y_now)); 

    // SQL request
    $db = dbconnect();
    $query="select sum(time) as ontime 
            from conns
            where start>='$begin 00:00:00' and start<='$end 23:59:59'";
    $result=pg_exec($db,$query);

    // get the ontime
    $ontime=pg_result($result,"0","ontime");
    $t_ontime=sec_to_time($ontime);

    // format and print the date and ontime
    if (strlen("$t_ontime")<9) { $f_ontime="0". $t_ontime; }
    else { $f_ontime=$t_ontime; }
    $text .= "<TR><TD><FONT FACE=Helvetica,Arial>$m : </FONT></TD>\n";
    $text .= "<TD><FONT FACE=HELVETICA,ARIAL> $f_ontime </FONT></TD>";
    
    // set the scale
    $max=$ontime / 5000;

    // calculate the size of the bar
    $size=0;
    $color="$sec_tcolor";
    for ($j=1;$j<$max;$j++) {
      $size++;
      $color="$dark_color";
    }

    // print the bar
    $text .= "<TD><TABLE BGCOLOR=0 COLSPAN=0 CELLPADDING=0><TR>\n";
    $text .= "<TD BGCOLOR=\"$color\" WIDTH=$size><FONT SIZE=-2>&nbsp;</FONT></TD></TR>\n";
    $text .= "</TABLE></TD></TR>\n";
  }
  $text .= "</TABLE>\n";

  // print the resulting report
  $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,$lang_stats_Monthes,$titre_color); 
  $val = center($val);
  $val = saut(2)."$val";
  print $val;
}  

// The end
print endHTML();

?>
